package com.franckbarbier.Android;

class EventSniffer /* extends android.content.BroadcastReceiver */ {

//    @Override
//    public void onReceive(android.content.Context arg0, android.content.Intent arg1) {
//        if (arg1 != null && arg1.getAction() != null) {
//            android.content.Intent intent = new android.content.Intent(arg0, Android_energy_management.class);
//            intent.setAction(arg1.getAction());
//            arg0.startService(intent);
//        }
//    }
}

public class Android_energy_management /* extends android.app.Service */ {

    private EventSniffer _event_sniffer;

    private com.pauware.pauware_engine.Core.AbstractState _Nominal_Energy_Level;
    private com.pauware.pauware_engine.Core.AbstractState _Critical_Energy_Level;
    private com.pauware.pauware_engine.Core.AbstractState _Energy_leak;
    private com.pauware.pauware_engine.Core.AbstractState _Energy_saving;
    private com.pauware.pauware_engine.Core.AbstractStateMachine _Android_energy_management_state_machine;

    private void init_structure() {
        _event_sniffer = new EventSniffer();
    }

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Nominal_Energy_Level = new com.pauware.pauware_engine.Core.State("Nominal energy Level");
        _Nominal_Energy_Level.inputState();
        _Energy_leak = new com.pauware.pauware_engine.Core.State("Energy leak");
        _Energy_leak.inputState();
        _Energy_saving = new com.pauware.pauware_engine.Core.State("Energy saving");
        _Critical_Energy_Level = (_Energy_leak.xor(_Energy_saving)).name("Critical energy Level");
        _Android_energy_management_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Nominal_Energy_Level.xor(_Critical_Energy_Level), "Android energy management", com.pauware.pauware_engine.Core.AbstractStateMachine.Don_t_show_on_system_out, new com.pauware.pauware2web.PauWare2Web_client());
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Android_energy_management_state_machine.fires("Intent.ACTION_BATTERY_LOW", _Nominal_Energy_Level, _Critical_Energy_Level);
        _Android_energy_management_state_machine.fires("Intent.ACTION_POWER_CONNECTED", _Critical_Energy_Level, _Critical_Energy_Level);
        _Android_energy_management_state_machine.fires("Intent.ACTION_POWER_DISCONNECTED", _Critical_Energy_Level, _Critical_Energy_Level);
        _Android_energy_management_state_machine.fires("Intent.ACTION_NEW_OUTGOING_CALL", _Critical_Energy_Level, _Critical_Energy_Level);
        _Android_energy_management_state_machine.fires("Intent.ACTION_BATTERY_OKAY", _Critical_Energy_Level, _Nominal_Energy_Level);
        _Android_energy_management_state_machine.fires("Intent.ACTION_SCREEN_OFF", _Energy_leak, _Energy_saving);
        _Android_energy_management_state_machine.fires("Intent.ACTION_SCREEN_ON", _Energy_saving, _Energy_leak);
        _Android_energy_management_state_machine.start();
    }

    public void stop() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Android_energy_management_state_machine.stop();
    }

    public Android_energy_management() throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_structure();
        init_behavior();
    }

    public static void main(String args[]) {
        try {
            Android_energy_management aem = new Android_energy_management();
            aem.start();
            aem.stop();
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }
}
